//----------------------------------------------------------------
//Code Art.
//
//ļ:
//
//  : jianyi0115@163.com
//: 2008-1-14
//
//޶¼: 
//
//----------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Reflection;

namespace CodeArt.SharePoint.WebParts
{
    public class EditControlListFieldIterator : Microsoft.SharePoint.WebControls.ListFieldIterator
    {

        protected override void CreateChildControls()
        {
            //ֻ༭ģʽ
            if (this.ControlMode != SPControlMode.Edit)
            {
                base.CreateChildControls();
                return;
            }

            SPUser currentUser = SPContext.Current.Web.CurrentUser ;

            //վԱԱ༭ֶ
            if (currentUser.IsSiteAdmin)
            {
                base.CreateChildControls();
                return;
            }

            //ȡȨϢ
            ListFieldEditSetting listSetting = ListFieldEditSetting.GetListSetting( this.ListId ) ;
            if( listSetting == null || listSetting.Count == 0 )
            {
                base.CreateChildControls();
                return ;
            }

            //base.CreateChildControls();
            this.Controls.Clear();
            if (this.ControlTemplate == null)
            {
                throw new ArgumentException("Could not find ListFieldIterator control template.");
            }

            SPFieldUserValue authorFieldValue = new SPFieldUserValue ( SPContext.Current.Web , ""+ this.ListItem["Author"] ) ;
            SPUser author = authorFieldValue.User;

            Type t = typeof(TemplateContainer);

            //ȡTemplateContainerControlMode
            PropertyInfo ControlModeProp = t.GetProperty("ControlMode", BindingFlags.Instance | BindingFlags.NonPublic);
            PropertyInfo FieldNameProp = t.GetProperty("FieldName", BindingFlags.Instance | BindingFlags.NonPublic); 

            for (int i = 0; i < base.Fields.Count; i++)
            {
                SPField field = base.Fields[i];

                if (!this.IsFieldExcluded(field))
                {
                    TemplateContainer child = new TemplateContainer();

                    this.Controls.Add(child);

                    FieldEditSetting set = listSetting.GetByFieldName(field.InternalName);

                    if (set != null && !set.CanEdit(currentUser, author))
                    {
                        //child.ControlMode = base.ControlMode;
                        //child.FieldName = field.InternalName;
                        //ControlModeProp.SetValue(child, this.ControlMode,null);
                        ControlModeProp.SetValue(child, SPControlMode.Display, null);
                    }

                    FieldNameProp.SetValue(child, field.InternalName, null);

                    this.ControlTemplate.InstantiateIn(child);

                }
            }

        }
 

    }
}
